SoLineDetail Class Reference

| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | List of all members
SoLineDetail Class Reference
Detail Classes

The SoLineDetail class is for storing detailed 3D line information.Instances of this class are used among other things for storing information about lines after pick operations, and for storing information returned to tessellation callbacks. More...

`#include <Inventor/details/SoLineDetail.h>`

Inheritance diagram for SoLineDetail:

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoLineDetail (void)
virtual | ~SoLineDetail ()
virtual SoDetail * | copy (void) const
const SoPointDetail * | getPoint0 (void) const
const SoPointDetail * | getPoint1 (void) const
int | getLineIndex (void) const
int | getPartIndex (void) const
void | setPoint0 (const SoPointDetail *const detail)
void | setPoint1 (const SoPointDetail *const detail)
void | setLineIndex (const int idx)
void | setPartIndex (const int idx)
void | incLineIndex (void)
void | incPartIndex (void)
Public Member Functions inherited from SoDetail
virtual | ~SoDetail ()
SbBool | isOfType (const SoType type) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | cleanupClass (void)
static void | initClass (void)
Static Public Member Functions inherited from SoDetail
static void | initClass (void)
static void | initClasses (void)
static SoType | getClassTypeId (void)

## Additional Inherited Members
Protected Member Functions inherited from SoDetail
| SoDetail (void)

## Detailed Description

The SoLineDetail class is for storing detailed 3D line information.

Instances of this class are used among other things for storing information about lines after pick operations, and for storing information returned to tessellation callbacks.

See also
  SoRayPickAction, SoPickedPoint, SoCallbackAction

## Constructor & Destructor Documentation

SoLineDetail::SoLineDetail | ( | void |  | ) |

Default constructor sets up an empty, non-valid detail specification.

SoLineDetail::~SoLineDetail | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

SoType SoLineDetail::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of a detail derived from a class inheriting SoDetail. This is used for run-time type checking and "downward" casting.

Usage example:

void fuhbear(SoDetail * detail)
{
if (detail->getTypeId() == SoFaceDetail::getClassTypeId()) {
// safe downward cast, know the type
SoFaceDetail * facedetail = (SoFaceDetail *)detail;
}
return; // ignore if not a SoFaceDetail
}

For application programmers wanting to extend the library with new detail classes: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through Inventor/nodes/SoSubDetail.h: SO_DETAIL_SOURCE and SO_DETAIL_INIT_CLASS.

Implements SoDetail.

SoDetail * SoLineDetail::copy | ( | void |  | ) | const
| virtual

Return a deep copy of ourself.

Note that if the Coin library has been built as a DLL under Microsoft Windows and you use this method from application code, you must make sure that both the Coin DLL and the application executable is using the same instance of a C Run-Time (CRT) library. Otherwise, you will get memory heap corruption upon deallocating the returned instances, eventually leading to mysterious crashes.

Implements SoDetail.

const SoPointDetail * SoLineDetail::getPoint0 | ( | void |  | ) | const

Returns SoPointDetail describing the line start point.

const SoPointDetail * SoLineDetail::getPoint1 | ( | void |  | ) | const

Returns SoPointDetail describing the line end point.

int SoLineDetail::getLineIndex | ( | void |  | ) | const

Returns the index of this line within the lineset node it is part of.

int SoLineDetail::getPartIndex | ( | void |  | ) | const

Returns the index of this line within the complex shape node it is part of.

void SoLineDetail::setPoint0 | ( | const SoPointDetail *const | detail | ) |

Stores information about line's start point. Used internally from library client code setting up a SoLineDetail instance.

See also
  getPoint0()

void SoLineDetail::setPoint1 | ( | const SoPointDetail *const | detail | ) |

Stores information about line's end point. Used internally from library client code setting up a SoLineDetail instance.

See also
  getPoint1()

void SoLineDetail::setLineIndex | ( | const int | idx | ) |

Used internally from library client code setting up a SoLineDetail instance.

See also
  getLineIndex()

void SoLineDetail::setPartIndex | ( | const int | idx | ) |

Used internally from library client code setting up a SoLineDetail instance.

See also
  getPartIndex()

void SoLineDetail::incLineIndex | ( | void |  | ) |

Convenience method for library client code when setting up a SoLineDetail instance to use the line index as a counter.

void SoLineDetail::incPartIndex | ( | void |  | ) |

Convenience method for library client code when setting up a SoLineDetail instance to use the part index as a counter.

The documentation for this class was generated from the following files:

- SoLineDetail.h
- SoLineDetail.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.